import java.io.*;
import java.util.*;

public class bunny
{
	public static void main(String[] args)
	{
		FastScanner in = new FastScanner();
		int n = in.nextInt();
		int q = in.nextInt();
		
		BIT bit = new BIT(n);
		for(int i = 0; i < n; i++)
			bit.add(i, Long.numberOfTrailingZeros(check(in.nextLong())));
		
		for(int i = 0; i < q; i++)
		{
			int cmd = in.nextInt();
			if(cmd == 1)
			{
				int j = in.nextInt()-1;
				int x = Long.numberOfTrailingZeros(check(in.nextLong()));
				
				bit.add(j, x);
			}
			else if(cmd == 2)
			{
				int l1 = in.nextInt()-1;
				int r1 = in.nextInt()-1;
				int l2 = in.nextInt()-1;
				int r2 = in.nextInt()-1;
				
				int sum1 = bit.sum(l1, r1);
				int sum2 = bit.sum(l2, r2);
				
				System.out.println(Integer.compare(sum1, sum2));
			}
			else
			{
				//Wrong command
				System.out.println(1/0);
			}
		}
	}
	
	private static long check(long x)
	{
		if(Long.bitCount(x) != 1)
			System.out.println(1/0);
		return x;
	}

	public static class BIT
	{
		int bit[];
		
		public BIT(int n)
		{
			bit = new int[n+1];
		}
		
		public void add(int i, int v)
		{
			i++;
			
			while(i < bit.length)
			{
				bit[i] += v;
				i += i&-i;
			}
		}
		
		public int sum(int i)
		{
			i++;
			int sum = 0;
			
			while(i > 0)
			{
				sum += bit[i];
				i -= i&-i;
			}
			
			return sum;
		}
		
		public int sum(int l, int r)
		{
			if(l == 0)
				return sum(r);
			if(l > r)
				return 0;
			
			return sum(r) - sum(l-1);
		}
	}

	public static class FastScanner
	{
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(String s)
		{
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public FastScanner()
		{
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		String nextToken()
		{
			while (st == null || !st.hasMoreElements())
			{
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt()
		{
			return Integer.parseInt(nextToken());
		}

		long nextLong()
		{
			return Long.parseLong(nextToken());
		}

		double nextDouble()
		{
			return Double.parseDouble(nextToken());
		}
		
		String next()
		{
			return nextToken();
		}
	}
}
