import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.InputMismatchException;

public class bunny_jacob {

	static class Solver {

		int N, Q;
		BIT BIT;

		int log(long a) {
			return Long.numberOfTrailingZeros(a);
		}

		void solve(FastScanner s, PrintWriter out) {

			N = s.nextInt();
			Q = s.nextInt();
			BIT = new BIT(N);

			for (int i = 1; i <= N; i++)
				BIT.update(i, log(s.nextLong()));

			for (int q = 0; q < Q; q++) {
				if (s.nextInt() == 1) {
					BIT.update(s.nextInt(), log(s.nextLong()));
				} else {
					int a = s.nextInt(), b = s.nextInt();
					int c = s.nextInt(), d = s.nextInt();
					int x = BIT.rsq(a, b), y = BIT.rsq(c, d);
					if (x == y)
						out.println(0);
					else
						out.println(x > y ? 1 : -1);
				}
			}

		}

		class BIT {
			int[] dat;
			int N;

			public BIT(int NN) {
				N = NN;
				dat = new int[N + 1];
			}

			public void inc(int ind) {
				this.update(ind, 1);
			}

			public void dec(int ind) {
				this.update(ind, -1);
			}

			public void update(int ind, int delta) {
				while (ind <= N) {
					dat[ind] += delta;
					ind += (ind & -ind);
				}
			}

			public int pre(int i) {
				int sum = 0;
				while (i > 0) {
					sum += dat[i];
					i -= (i & -i);
				}
				return sum;
			}

			public int get(int i) {
				return rsq(i, i);
			}

			public int rsq(int i, int j) {
				return pre(j) - pre(i - 1);
			}

		}

	}

	public static void main(String[] args) {

		FastScanner s = new FastScanner(System.in);
		PrintWriter out = new PrintWriter(System.out);

		Solver solver = new Solver();
		solver.solve(s, out);

		out.close();

	}

	static class FastScanner {
		private InputStream stream;
		private byte[] buf = new byte[1024];
		private int curChar;
		private int numChars;

		public FastScanner(InputStream stream) {
			this.stream = stream;
		}

		int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}

		public int[] nextIntArray(int n) {
			int[] ret = new int[n];
			for (int i = 0; i < n; i++)
				ret[i] = nextInt();
			return ret;
		}

		public String next() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

	}

}
