package divisors;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.InputMismatchException;

public class divisors_jacob {

	static class Solver {

		int L, P;
		long K;
		long[] inp;
		int[] exp;

		HashMap<Integer, Integer> N = new HashMap<>();

		void add(long c) {
			int i = 2;
			while (c > 1)
				while (c % i++ == 0) {
					N.put(i, N.getOrDefault(i, 0) + 1);
					c /= --i;
				}
		}

		HashMap<Long, Long> memo = new HashMap<>();

		long hash(int p, long k) {
			return k * 100 + p;
		}

		long dp(int p, long k) {
			if (k == 1)
				return 1;
			if (p == P)
				return 0;
			if (memo.containsKey(hash(p, k)))
				return memo.get(hash(p, k));
			long res = 0;
			for (int i = 1; i <= exp[p] + 1; i++)
				if (k % i == 0)
					res += dp(p + 1, k / i);
			memo.put(hash(p, k), res);
			return res;
		}

		void solve(FastScanner s, PrintWriter out) {

			L = s.nextInt();
			K = s.nextLong();
			inp = s.nextLongArray(L);
			for (long c : inp)
				add(c);
			P = N.size();
			exp = new int[P];
			int j = 0;
			for (int i : N.keySet())
				exp[j++] = N.get(i);

			out.println(dp(0, K));

		}

	}

	public static void main(String[] args) {

		FastScanner s = new FastScanner(System.in);
		PrintWriter out = new PrintWriter(System.out);

		Solver solver = new Solver();
		solver.solve(s, out);

		out.close();

	}

	static class FastScanner {
		private InputStream stream;
		private byte[] buf = new byte[1024];
		private int curChar;
		private int numChars;

		public FastScanner(InputStream stream) {
			this.stream = stream;
		}

		int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}

		public long[] nextLongArray(int N) {
			long[] ret = new long[N];
			for (int i = 0; i < N; i++)
				ret[i] = this.nextLong();
			return ret;
		}

		public int[] nextIntArray(int n) {
			int[] ret = new int[n];
			for (int i = 0; i < n; i++)
				ret[i] = nextInt();
			return ret;
		}

		public String next() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

	}

}
