// Arup Guha
// 4/4/2018
// Solution to 2018 COP 4516 Final Team Exam Problem F: Finicky Anya!
// Edited on 7/2/2018 for SI@UCF Contest #1 to do one case per file.

import java.util.*;

public class finicky {

	public static int len;
	public static int n;
	public static item[] list;

	public static Integer[][] memo;

	public static void main(String[] args) {

		Scanner stdin = new Scanner(System.in);

		// Get basic parameters.
		int happy = stdin.nextInt();
		len = stdin.nextInt();
		n = stdin.nextInt();

		// Store stations to buy stuff here - dummy station at beginning and end.
		list = new item[n+2];
		list[0] = new item(0, 0, 0);
		for (int i=1; i<=n; i++) {
			int loc = stdin.nextInt();
			int cost = stdin.nextInt();
			int val = stdin.nextInt();
			list[i] = new item(loc, cost, val);
		}
		list[n+1] = new item(len, 0, 0);

		// Store answers to recursive subcalls here.
		memo = new Integer[n+1][len+1];
		for (int i=0; i<=n; i++) Arrays.fill(memo[i], null);

		// Solve it.
		System.out.println(solve(0, happy));
	}

	// Min solution starting from state (i, happy).
	public static int solve(int i, int happy) {

		// Oops!
		if (happy < 0) return -1;

		// This means we made it.
		if (i > n) return 0;

		// We don't have to buy anything more.
		if (happy >= len - list[i].loc) return 0;

		// Did this case before.
		if (happy >= 0 && happy <= len && memo[i][happy] != null) return memo[i][happy];

		// Distance to next stand.
		int dist = list[i+1].loc - list[i].loc;

		// Min cost if we buy from stand i, for everything else.
		int buyRest = solve(i+1, happy - dist + list[i].hValue);

		// If we can't make it by buying here we are screwed.
		if (buyRest < 0) return -1;

		// Actual cost.
		int buy = buyRest + list[i].cost;

		// Otherwise, we try not to buy here.
		int nobuy = solve(i+1, happy - dist);

		// We want the better of the two answers, if both are valid, or buy otherwise.
		int res = nobuy < 0 ? buy : Math.min(buy, nobuy);

		// Store and return.
		return memo[i][happy] = res;
	}
}

class item {

	public int loc;
	public int cost;
	public int hValue;

	public item(int x, int c, int h) {
		loc = x;
		cost = c;
		hValue = h;
	}
}