/*
	grouping-bsearch.cpp
	Solution to "Cow Grouping"
	SIUCF CompProg Camp 2018, Contest 1

	problem and solution by Charles B.

	8 July 2018
*/
#include <bits/stdc++.h>

#define FI first
#define SE second

typedef long long ll;
typedef std::pair<ll,ll> pairll;

const static ll INF = 0x3f3f3f3f3f3f3f3f;

static inline void setio(void);

const ll MAX_M = 101, MAX_N = 300001;

std::vector<ll> pref[MAX_M];

int main(void) {
	setio();

	ll n,m; std::cin >> n >> m;

	for (ll i = 0; i < m; ++i)
		pref[i].assign(n+1, 0);

	for (ll i = 0, a_i; i < n; ++i) {
		std::cin >> a_i; --a_i;
		pref[a_i][i+1] = 1;
	}

	ll max_k = 0;
	for (ll i = 0; i < m; ++i) {
		for (ll j = 1; j <= n; ++j) {
			pref[i][j] += pref[i][j-1];
		}
		max_k = std::max(max_k, pref[i][n]);
	}

	ll k_count = 1;
	std::stringstream ans;
	ans << "1 " << n << "\n";

	for (ll k = 2; k <= max_k; ++k) {
		bool bad = false;
		ll start = 0;
		ll gc = 0;
		while (!bad && start < n) {
			ll min = INF;
			for (ll i = 0; i < m; ++i) {
				auto it = std::lower_bound(pref[i].begin() + start, pref[i].end(), pref[i][start] + k);
				const ll j = std::distance(pref[i].begin(), it);
				min = std::min(min, j);
			}
			bad = bad || min > n;
			start = min; ++gc;
		}
		if (!bad) {
			++k_count;
			ans << k << " " << gc << "\n";
		}
	}

	std::cout << k_count << "\n" << ans.rdbuf();

	std::cerr << std::setprecision(10) << static_cast<double>(clock())/CLOCKS_PER_SEC << "\n";

	return 0;
}

static inline void setio(void) {
	std::ios::sync_with_stdio(false);std::cin.tie(nullptr);
	std::cout.precision(10); std::cout << std::fixed;
}
