/*
	grouping.cpp
	Solution to "Cow Grouping"
	SIUCF CompProg Camp 2018, Contest 1

	problem and solution by Charles B.

	8 July 2018
*/
#include <bits/stdc++.h>

#define FI first
#define SE second

typedef int ll;
typedef std::pair<ll,ll> pairll;

const ll INF = 0x3f3f3f3f;
const ll MAX_N = 300002, MAX_M = 101;

ll prefix[MAX_M][MAX_N];
ll nth[MAX_M][MAX_N];

pairll ans[MAX_N];

static inline void setio(void);

int main(void) {
	setio();

	for (ll i = 0; i < MAX_M; ++i)
		prefix[i][0] = 0;

	ll n, m, max_k = 0; std::cin >> n >> m;

	for (ll i = 1, a; i <= n; ++i) {
		std::cin >> a; --a;
		prefix[a][i] = 1;
		for (ll j = 0; j < m; ++j)
			prefix[j][i] += prefix[j][i-1];
		nth[a][prefix[a][i]] = i-1;
		max_k = std::max(max_k, prefix[a][i]);
	}

	ll count = 0; ans[count++] = pairll{1, n};

	for (ll k = 2; k <= max_k; ++k) {
		bool good = true;
		ll start = 0, gc = 0, min = 0;
		while (good && start < n) {
			min = INF;
			for (ll i = 0; i < m; ++i) {
				ll val = prefix[i][start] + k;
				min = std::min(min, val > prefix[i][n] ? INF : nth[i][val]);
			}
			good = good && min <= n;
			start = min+1; ++gc;
		}

		if (good) {
			ans[count++] = pairll{k, gc};
		}
	}

	std::cout << count << "\n";
	for (ll i = 0; i < count; ++i)
		std::cout << ans[i].FI << " " << ans[i].SE << "\n";

	// std::cerr << std::setprecision(3) << static_cast<double>(clock())/CLOCKS_PER_SEC << "\n";

	return 0;
}

static inline void setio(void) {
	std::ios::sync_with_stdio(false);std::cin.tie(nullptr);
	std::cout.precision(10); std::cout << std::fixed;
}
