package grouping;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.InputMismatchException;

public class grouping_jacob {

	static class Solver {

		int N, M, a[], to[][], cs[][];

		void solve(FastScanner s, PrintWriter out) {

			long tt = System.currentTimeMillis();

			N = s.nextInt();
			M = s.nextInt();
			a = s.nextIntArray(N);
			to = new int[M][N << 1];
			cs = new int[M][N << 1];

			for (int[] x : to)
				Arrays.fill(x, -1);
			for (int i = 0; i < N; i++) {
				int t = a[i] - 1;
				cs[t][i + 1]++;
				for (int j = 0; j < M; j++)
					cs[j][i + 1] += cs[j][i];
				to[t][cs[t][i + 1]] = i;
			}

			ArrayList<int[]> sols = new ArrayList<>();

			// i - left bound
			// j - variable right bound
			// g - groups made
			// q - how many of each breed used so far
			int i, j, g, q[];
			chk: for (int k = 1; k <= N; k++) {
				q = new int[M];
				i = g = 1;
				while (i <= N) {
					j = N;
					// d is breed of next leader
					for (int d = 0; d < M; d++) {
						if (to[d][q[d] + k] == -1)
							continue;
						j = Math.min(j, to[d][q[d] + k]);
					}
					if (j == N - 1)
						sols.add(new int[] { k, g });
					if (j >= N - 1)
						continue chk;
					g++;
					i = j + 1;
					for (int d = 0; d < M; d++)
						q[d] = cs[d][i];
				}
			}

			out.println(sols.size());
			for (int[] x : sols)
				out.printf("%d %d%n", x[0], x[1]);

			tt = System.currentTimeMillis() - tt;
			System.err.printf("%.6f%n", tt / 1000.0);

		}

	}

	public static void main(String[] args) {

		FastScanner s = new FastScanner(System.in);
		PrintWriter out = new PrintWriter(System.out);

		Solver solver = new Solver();
		solver.solve(s, out);

		out.close();

	}

	static class FastScanner {
		private InputStream stream;
		private byte[] buf = new byte[1024];
		private int curChar;
		private int numChars;

		public FastScanner(InputStream stream) {
			this.stream = stream;
		}

		int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public int[] nextIntArray(int n) {
			int[] ret = new int[n];
			for (int i = 0; i < n; i++)
				ret[i] = nextInt();
			return ret;
		}

		public String next() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

	}

}
