/*
	icecream.cpp
	Solution to "Anya and Ice Cream"
	SIUCF CompProg Camp 2018, Contest 1

	problem and solution by Charles B.

	29 Jun 2018
	3 July 2018 -- Updated for one case per file.
*/
#include <bits/stdc++.h>

#define FI first
#define SE second

typedef long long ll;
typedef std::pair<ll,ll> pairll;

static inline void setio(void);

const ll MAX_N = 100001;

ll pre[MAX_N], ans[MAX_N], vals[MAX_N];

std::vector<ll> kids[MAX_N];

int main(void) {
	setio();

	ll n, q; std::cin >> n >> q;
	for (ll i = 0; i < n; ++i)
		std::cin >> vals[i];

	for (ll i = 1, p; i < n; ++i) {
		std::cin >> p;
		kids[p-1].push_back(i);
	}

	/* recursive DFS can't handle 10^5 linked list !! :O */
	// std::function<ll(const ll&)>
	// dfs = [&](const ll& cur) {
	// 	pre[cur] = po++;
	// 	ans[pre[cur]] = vals[cur];
	// 	for (const auto& nei : kids[cur])
	// 		ans[pre[cur]] = std::max(ans[pre[cur]], dfs(nei));
	// 	return ans[pre[cur]];
	// };
	// dfs(0);

	ll po = 0;
	std::stack<pairll> stk;
	stk.push({0, 0});

	while (!stk.empty()) {
		pairll now = stk.top();
		stk.pop();

		if (now.SE == 0) {
			pre[now.FI] = po++;
			ans[pre[now.FI]] = vals[now.FI];
		}

		if (now.SE < static_cast<ll>(kids[now.FI].size())) {
			stk.push({now.FI, now.SE+1});
			stk.push({kids[now.FI][now.SE], 0});
		} else {
			for (const auto& kid : kids[now.FI])
				ans[pre[now.FI]] = std::max(ans[pre[now.FI]], ans[pre[kid]]);
		}
	}

	for (ll i, k; q--; ) {
		std::cin >> i >> k;
		std::cout << (ans[i-1] >= k ? "YES" : "NO") << "\n";
	}

	std::cerr << std::setprecision(6) << static_cast<double>(clock())/CLOCKS_PER_SEC << "\n";

	return 0;
}

static inline void setio(void) {
	std::ios::sync_with_stdio(false);std::cin.tie(nullptr);
	std::cout.precision(10); std::cout << std::fixed;
}
