// Arup Guha
// 7/3/2018
// Solution to 2018 SI@UCF Contest #1 Problem: Number of DFSs.

import java.util.*;

public class numdfs {
	
	public static int n;
	public static boolean[][] adj;
	public static int startV;
	
	public static void main(String[] args) {
		
		// Get basic graph info.
		Scanner stdin = new Scanner(System.in);
		n = stdin.nextInt();
		adj = new boolean[n][n];
		int e = stdin.nextInt();
		int startV = stdin.nextInt()-1;
		
		// Mark all valid vertices.
		for (int i=0; i<e; i++) {
			int v1 = stdin.nextInt()-1;
			int v2 = stdin.nextInt()-1;
			adj[v1][v2] = true;
			adj[v2][v1] = true;
		}
		
		// Need this to start everything off.
		boolean[] visited = new boolean[n];
		visited[startV] = true;
		int[] perm = new int[n];
		perm[0] = startV;
		
		// Ta da!
		System.out.println(dfs(1, perm, visited));
	}
	
	// Returns how many DFS's of this graph start with perm[0..k-1]
	public static int dfs(int k, int[] perm, boolean[] visited) {
		
		// Done.
		if (k == n) return 1;
		
		// Try each valid neighbor.
		int res = 0;
		boolean hadNeighbor = false;
		int prev = k-1;
		
		// We must "pop" our dfs stack until we have somewhere new to go.
		while (!hadNeighbor && prev >= 0) {
			
			hadNeighbor = false;
			
			// Try each new neighbor to visited.
			for (int i=0; i<n; i++) {
				if (!visited[i] && adj[perm[prev]][i]) {
					visited[i] = true;
					perm[k] = i;
					res += dfs(k+1, perm, visited);
					visited[i] = false;
					hadNeighbor = true;
				}
			}
		
			// Like popping the stack.
			prev--;
		}
		
		// Ta da!
		return res;
	}
}