import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Queue;
import java.util.Scanner;

public class paper_bill {
	
	static final int oo = 12345678; 

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int N = in.nextInt();
		int M = in.nextInt();
		int K = in.nextInt();
		int[] c = new int[K];
		for (int i = 0; i < K; ++i) c[i] = in.nextInt();
		List<Integer>[] adj = new List[N];
		for (int i = 0; i < N; ++i) adj[i] = new ArrayList<>();
		for (int i = 0; i < M; ++i) {
			int u = in.nextInt()-1;
			int v = in.nextInt()-1;
			adj[u].add(v);
			adj[v].add(u);
		}
		
		int[][] distTable = new int[K][];
		for (int i = 0; i < K; ++i) distTable[i] = dists(adj, i);
		
		int tot = 0;
		
		for (int i = K; i < N; ++i) {
			int q = oo;
			for (int j = 0; j < K; ++j) {
				q = Math.min(q, distTable[j][i] * c[j]);
			}
			tot += q;
		}
		
		System.out.println(tot);
	}
	
	static int[] dists(List<Integer>[] adj, int start) {
		int[] dist = new int[adj.length];
		Arrays.fill(dist, oo);
		Queue<Integer>[] qs = new Queue[] {new ArrayDeque<>(), new ArrayDeque<>()};
		int move = 0;
		qs[0].add(start);
		boolean[] closed = new boolean[adj.length];
		closed[start] = true;
		while (!qs[0].isEmpty() || !qs[1].isEmpty()) {
			Queue<Integer> active = qs[move&1];
			Queue<Integer> inactive = qs[move&1^1];
			while (!active.isEmpty()) {
				int u = active.poll();
				dist[u] = move;
				for (int v : adj[u]) {
					if (!closed[v]) {
						closed[v] = true;
						inactive.add(v);
					}
				}
			}
			
			++move;
		}
		
		return dist;
	}

}
