package paper;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.InputMismatchException;

public class paper_jacob {

	static class Solver {

		class Node {

			int min = oo;
			ArrayList<Integer> adj = new ArrayList<>();

		}

		int N, M, K, oo = 987654321, c[];
		Node[] nodes;

		void solve(FastScanner s, PrintWriter out) {

			N = s.nextInt();
			M = s.nextInt();
			K = s.nextInt();
			c = s.nextIntArray(K);

			nodes = new Node[N];
			for (int i = 0; i < N; i++)
				nodes[i] = new Node();

			for (int i = 0; i < M; i++) {
				int u = s.nextInt() - 1, v = s.nextInt() - 1;
				nodes[u].adj.add(v);
				nodes[v].adj.add(u);
			}

			ArrayDeque<Node> q = new ArrayDeque<>();
			boolean[] vis;
			Node cur;

			for (int k = 0; k < K; k++) {
				vis = new boolean[N];
				vis[k] = true;
				q.clear();
				q.add(nodes[k]);

				int dist = 0;
				while (!q.isEmpty()) {
					int len = q.size();
					while (len-- > 0) {
						cur = q.poll();
						cur.min = Math.min(cur.min, dist * c[k]);
						for (int i : cur.adj)
							if (!vis[i] && (vis[i] = true))
								q.add(nodes[i]);
					}
					dist++;
				}
			}

			int tot = 0;
			for (int n = K; n < N; n++)
				tot += nodes[n].min;

			out.println(tot);

		}

	}

	public static void main(String[] args) {

		FastScanner s = new FastScanner(System.in);
		PrintWriter out = new PrintWriter(System.out);

		Solver solver = new Solver();
		solver.solve(s, out);

		out.close();

	}

	static class FastScanner {
		private InputStream stream;
		private byte[] buf = new byte[1024];
		private int curChar;
		private int numChars;

		public FastScanner(InputStream stream) {
			this.stream = stream;
		}

		int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public int[] nextIntArray(int n) {
			int[] ret = new int[n];
			for (int i = 0; i < n; i++)
				ret[i] = nextInt();
			return ret;
		}

		public String next() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuilder res = new StringBuilder();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

	}

}
