/*
	rating.cpp
	Solution to "Retrospective Rating"
	SIUCF CompProg Camp 2018, Contest 1

	problem and solution by Charles B.

	1 July 2018
*/
#include <bits/stdc++.h>

#define FI first
#define SE second

typedef long long ll;

const static ll INF = 0x3f3f3f3f3f3f3f3f;

static inline void setio(void);

const static ll MAX_N = 500001;

ll negs[MAX_N];

int main(void) {
	setio();

	/* read in n and k. */
	ll n, k; std::cin >> n >> k;

	/*  Take in all of the deltas. We only care about the negative ones.
	    Non-negative can be discarded. */
	ll neg_count = 0;
	for (ll i = 0, tmp; i < n; ++i) {
		std::cin >> tmp;
		if (tmp < 0) negs[neg_count++] = tmp;
	}

	/* sort our negatives in increasing order */
	std::sort(negs, negs + neg_count);

	/* take the first k negatives, or neg_count if there are fewer than k. */
	ll ans = 0, lim = std::min(neg_count, k);
	for (ll i = 0; i < lim; ++i)
		ans -= negs[i]; /* add the negative to the answer. it's -= to cancel the negative. */

	/* print out answer */
	std::cout << ans << "\n";

	std::cerr << static_cast<double>(clock())/CLOCKS_PER_SEC << "\n";

	return 0;
}

static inline void setio(void) {
	std::ios::sync_with_stdio(false);std::cin.tie(nullptr);
	std::cout.precision(10); std::cout << std::fixed;
}
