/*
	rating.java
	Solution to "Retrospective Rating"
	SIUCF CompProg Camp 2018, Contest 1

	problem and solution by Charles B.

	2 July 2018
*/
import java.util.*;

public class rating {
	static final int MAX_N = 500001;
	static int[] negs = new int[MAX_N];

	public static void main(String [] args) {
		final long TIME = System.nanoTime();
		Scanner in = new Scanner(System.in);

		/* read in n,k */
		int n = in.nextInt(), k = in.nextInt(), neg_count = 0;

		/* read in the deltas and only store negative ones  */
		for (int i = 0, tmp; i < n; ++i) {
			tmp = in.nextInt();
			if (tmp < 0) negs[neg_count++] = tmp;
		}

		/* calculate how many deltas there are to remove */
		int ans = 0, lim = Math.min(neg_count, k);

		/* sort */
		Arrays.sort(negs);

		/* calculate answer */
		for (int i = 0; i < lim; ++i) {
			ans -= negs[i];
		}

		System.out.println(ans);
		// System.err.println( (double)(System.nanoTime() - TIME) * 1e-9);
	}
}
